<#ftl strip_whitespace=true />
<#--
  Copyright 2008 jpp Development Team
 
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at
 
      http://www.apache.org/licenses/LICENSE-2.0
 
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<#import "lib/type.ftl" as TYPE />
<#import "lib/method.ftl" as METHOD />
<#import "lib/field.ftl" as FIELD />
<#t>

<#if target.kind.interface > <#-- generate interface code -->

    <@METHOD.SIGNATURE model.addListenerMethod/>;
    <@METHOD.SIGNATURE model.removeListenerMethod/>;

<#else> <#-- generate class code -->

    <@FIELD.DECLARE model.handlerList "true" />
<#t>
    <@METHOD.SIGNATURE model.addHandlerMethod/>
    {
        ${model.handlerList.name}.add(arg_0);
    }

    <@METHOD.SIGNATURE model.removeHandlerMethod/>
    {
        ${model.handlerList.name}.remove(arg_0);
    }

    @SuppressWarnings("unchecked")
    <@METHOD.SIGNATURE model.cloneHandlersMethod/>
    {
        <#if target.threaded>synchronized(${model.handlerList.name}) {</#if>
        return (${model.handlerList.impl.qualifiedName}) ((${model.handlerList.impl.qualifiedName}) ${model.handlerList.name}).clone();
        <#if target.threaded>}</#if>
    }

<#list model.callHandlerMethods as callHandlerMethod>
    <@METHOD.SIGNATURE callHandlerMethod/>
    {
        boolean result = false;
        for(${model.handler.qualifiedBaseName} handler: <@METHOD.CALL model.cloneHandlersMethod />)
        {
            result = handler.<@METHOD.CALL model.handlerMethods[callHandlerMethod_index] />;
            if ( result )
            {
                break;
            }
        }
        return result;
    }
</#list>

</#if>
