<#ftl strip_whitespace=true />
<#--
  Copyright 2008 jpp Development Team
 
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at
 
      http://www.apache.org/licenses/LICENSE-2.0
 
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<#import "lib/type.ftl" as TYPE />
<#import "lib/method.ftl" as METHOD />
<#import "lib/field.ftl" as FIELD />
<#t>

    private static final java.util.ServiceLoader<${target.name.qualifiedName}> _factoryLoader = java.util.ServiceLoader.load(${target.name.qualifiedName}.class);
<#if ! target.modifiers.abstract>
    private static final java.util.ServiceLoader<${source.name.qualifiedName}> _instanceLoader = java.util.ServiceLoader.load(${source.name.qualifiedName}.class);
</#if>

    public static ${target.name.qualifiedName} newInstance()
    {
<#if ! target.modifiers.abstract>
        java.util.Iterator<${target.name.qualifiedName}> iterator = _factoryLoader.iterator();
        return iterator.hasNext() ? iterator.next() : new ${target.name.simpleName}();
<#else>
        return _factoryLoader.iterator().next();
</#if>
    }

<#if ! target.modifiers.abstract >
    public ${source.name.qualifiedName} new${source.name.simpleName}()
    {
        ${source.name.qualifiedName} instance = _instanceLoader.iterator().next();
<#if source.init??>
        initInstance(instance);
</#if>
        return instance;
    }
<#if source.init??>
    protected void initInstance(${source.name.qualifiedName} instance)
    {
<#if source.init.modifiers.public>
        instance.${source.init.name}();
<#else>
        try
        {
            java.lang.reflect.Method method = ${source.name.qualifiedName}.class.getDeclaredMethod("${source.init.name}");
            boolean accessible = method.isAccessible();
            method.setAccessible(true);
            method.invoke(instance);
            method.setAccessible(accessible);
        }
        catch (Exception x)
        {
            throw new IllegalStateException(x);
        }
</#if>
    }
</#if>


<#else>
    public abstract ${source.name.qualifiedName} new${source.name.simpleName}();
</#if>
